#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <time.h>
#include <dos.h>

typedef struct {
	int valore;
	int seme; } Carta;

typedef struct {
	Carta carta[40];
 	int n; } Mazzo;

typedef struct {
	Carta carta[3];
 	int n; } CarteInMano;

typedef struct {
	Carta carta[22];
 	int n; } CarteSulTavolo;
 	
typedef struct {
	Carta ultima;
 	int tot; } Mazzetto;

typedef struct {
	CarteInMano carte;
 	Mazzetto mazzetto;
	char nome[13]; } Giocatore;

typedef struct {
	Giocatore giocatore[2];
  	CarteSulTavolo tavolo; 
	Mazzo mazzo; } Gioco;

void mossaComputer(Gioco *g);
int controlloTavolo(Carta c, CarteSulTavolo t);
void distribuisciTavolo(CarteSulTavolo *t,Mazzo *m);
void distribuisciCarte (Giocatore *g, Mazzo *m);
void inizializzaGrafica(void);
void disegnaCarte(CarteInMano c,char nome[]);
void rubaMazzo(Mazzetto *d, Mazzetto *s);
void lasciaCarta(Gioco *g, int cmano, int gioc);
void prendiCarta(Gioco *g,int cmano,int ctav,int gioc);
void regole(void);
void inizializza (Gioco *m);
void mischiaMazzo (Mazzo *m);
int vincitore(Giocatore g[]);
int controlloMazzetto(Carta gioc, Carta avv);
void mossaGiocatore(Gioco *g);
void disegnaTavolo(Gioco g);
void disegnaMazzo(void);
void disegnaMazzetto(Mazzetto m);
void disegnaPc(int n);
void disegnaMazzetto2(Mazzetto m);
void disegnaCartaTavolo(Carta c,int xx1, int yy1);
void disegnaCarta(Carta c, int xx1, int yy1);
void disegnaCarteTavolo(CarteSulTavolo t);
void pulisciMosse(void);
void illuminaCarta(int n);
void togliIlluminazione(void);
void illuminaNome(char nome[],int x);
void cancellaSchermo(int tot);
void introduzione(char nome[]);
void intrNome(char nome[]);
int menu(char nome[]);
void titolo(void);
void fine(void);
void grVincitore(char nome[],int xnome);
void grPareggio(void);
void cancellaStory(int y1, int n);
void copiaStringa(char dest[], char src1[], char src2[]);

/** MAIN **/

int main()
{
	 Gioco g;
	 int esci;
	 inizializzaGrafica();
	 introduzione(g.giocatore[0].nome);
	 do {
		inizializza(&g);
		mischiaMazzo(&g.mazzo);
		distribuisciTavolo(&g.tavolo, &g.mazzo);
		distribuisciCarte(&(g.giocatore[0]),&(g.mazzo));
		distribuisciCarte(&(g.giocatore[1]),&(g.mazzo));
		do {
			esci=menu(g.giocatore[0].nome); }
		while(esci==49||esci==50);
		if (esci==51) {
			do {
				mossaGiocatore(&g);
				mossaComputer(&g);}
			while((g.mazzo.n!=0) || (g.giocatore[1].carte.n!=0));
			disegnaTavolo(g);
			delay(1000);
			esci=vincitore(g.giocatore);
		}
    }while(esci==0);
	 fine();
	 return 0;
}

/** DEFINIZIONE DELLE FUNZIONI DI GIOCO **/

void inizializza (Gioco *m)
// inizializza il gioco: mazzo, carte dei giocatori e mazzetti
{
    int i,j,puntatore=0;
	 for(i=3;i<=6;i++)
        for(j=1;j<=10;j++,puntatore++)
        {
            m->mazzo.carta[puntatore].valore=j;
            m->mazzo.carta[puntatore].seme=i;
        }
    m->mazzo.n=40;
	 m->giocatore[0].carte.n=0;
    m->giocatore[1].carte.n=0;
    m->giocatore[0].mazzetto.tot=0;
    m->giocatore[1].mazzetto.tot=0;
    m->tavolo.n=0;
    m->giocatore[0].mazzetto.ultima.valore=0;
    m->giocatore[0].mazzetto.ultima.seme=1;
	 m->giocatore[1].mazzetto.ultima.valore=0;
    m->giocatore[1].mazzetto.ultima.seme=1;
}

void mischiaMazzo (Mazzo *m)
// mischia il mazzo "m" ordinato
{
    int i,j,punt=0;
    randomize();
    Carta temp;
    for(punt=0;punt<100;punt++)
    {
        i=rand()%40;
        j=rand()%40;
        temp=m->carta[j];
        m->carta[j]=m->carta[i];
        m->carta[i]=temp;
    }
}

void distribuisciTavolo(CarteSulTavolo *t,Mazzo *m)
//distribuisce le 4 carte,togliendole dal mazzo "m" e mettendole sul tavolo "t"
{
     int i=0;
     t->n=0;
     for(i=0;i<4;i++) {
     t->carta[i]=m->carta[(m->n)-1];
     m->n--; }
     t->n=4;
}

void distribuisciCarte(Giocatore *g,Mazzo *m)
//distribuisce le 3 carte al giocatore, togliendole dal mazzo
{
     int i;
     for(i=0;i<3;i++) {
     g->carte.carta[i]=m->carta[(m->n)-1];
     m->n--; }
	  g->carte.n=3;
}

void mossaGiocatore(Gioco *g)
//viene eseguita la mossa scelta del giocatore e viene modificata la situazione di gioco
{
	 int carta,pos=-1,contr=-1,mossa;
	 char cart[2]="a";
	 char moss[2]="a";
	 char mess[100];
	 if (g->giocatore[1].carte.n==0) {
		  distribuisciCarte(&(g->giocatore[0]),&(g->mazzo));
		  distribuisciCarte(&(g->giocatore[1]),&(g->mazzo)); }
	 disegnaTavolo(*g);
	 illuminaNome(g->giocatore[0].nome,60);
	 copiaStringa(mess,g->giocatore[0].nome,"'s turn");
	 outtextxy(10,445,mess);
	 cancellaStory(463,13);
    do{

		  outtextxy(10,410,"Carta -> ");
		  do {
			carta=getch(); }
		  while((carta>(g->giocatore[0].carte.n+48))||((carta!=49) && (carta!=50) && (carta!=51)&& (carta!=27)));
		  if (carta==27)
				fine();
		  cart[0]=carta;
		  outtextxy(90,410,cart);
		  carta=carta-49;
		  illuminaCarta(carta);
		  outtextxy(10,420,"Mossa: M - ruba mazzetto  T - prendi tavolo  L - lascia tavolo -> ");
		  do {
				mossa=getch(); }
		  while (mossa!=77 && mossa!=84 && mossa!=76 && mossa!=27);
		  if (mossa==27)
				fine();
		  moss[0]=mossa;
		  outtextxy(540,420,moss);
		  pulisciMosse();
		  if (mossa==77)
        {
            if(controlloMazzetto(g->giocatore[0].carte.carta[carta],g->giocatore[1].mazzetto.ultima)==1)
                contr=0;
        }
		  else if (mossa==84)
		  {
				pos=controlloTavolo(g->giocatore[0].carte.carta[carta],g->tavolo);
            if (pos!=-1)                       
                contr=1;
        }
        else
        {
            contr=2;
		  }
	 togliIlluminazione();
    }while (contr==-1);

    switch(contr)
    {
        case 0:
        {
				rubaMazzo(&(g->giocatore[0].mazzetto),&(g->giocatore[1].mazzetto));
            g->giocatore[0].carte.carta[carta] = g->giocatore[0].carte.carta[(g->giocatore[0].carte.n)-1];
				g->giocatore[0].carte.n--;
            g->giocatore[1].mazzetto.ultima.valore=0;
				g->giocatore[1].mazzetto.ultima.seme=1;
				copiaStringa(mess,g->giocatore[0].nome,"ha rubato il mazzo!!!");
				outtextxy(10,465,mess);
				break;
        }
        case 1:
        {
				prendiCarta(g,carta,pos,0);
				copiaStringa(mess,g->giocatore[0].nome,"ha preso una carta dal tavolo.");
				outtextxy(10,465,mess);
				break;
        }
        case 2:
		  {
				lasciaCarta(g,carta,0);
				copiaStringa(mess,g->giocatore[0].nome,"ha lasciato una carta sul tavolo.");
				outtextxy(10,465,mess);
            break;
        }
	 }
}

void mossaComputer(Gioco *g)
//viene eseguita la mossa del computer e modificato il gioco
{
	  int i=0,tav,c1;
     int contr=0;
	  g->giocatore[1].carte.n= g->giocatore[0].carte.n+1;
	  disegnaTavolo(*g);
	  cancellaStory(453,11);
	  illuminaNome("Computer",435);
	  outtextxy(10,445,"Il computer sta eleborando la mossa da fare...");
	  delay(2500);
	  i=0;

     do {
			if(controlloMazzetto(g->giocatore[1].carte.carta[i],g->giocatore[0].mazzetto.ultima)==1) {
            rubaMazzo(&(g->giocatore[1].mazzetto),&(g->giocatore[0].mazzetto));
				g->giocatore[1].carte.carta[i] = g->giocatore[1].carte.carta[(g->giocatore[1].carte.n)-1];
            g->giocatore[1].carte.n--;
            g->giocatore[0].mazzetto.ultima.valore=0;
            g->giocatore[0].mazzetto.ultima.seme=1;
				contr=1;
				outtextxy(10,455,"Il computer ha rubato il mazzo!!!"); }
     i++;
     }
     while((i<(g->giocatore[1].carte.n))&&(contr==0));
	  if(contr==0) {
             c1=-1;
            do{
                     c1++;
                     tav=controlloTavolo(g->giocatore[1].carte.carta[c1],g->tavolo);
                     }
            while((tav==-1) && (c1<(g->giocatore[1].carte.n)));
							if(tav==-1) {
								lasciaCarta(g,0,1);
								outtextxy(10,455,"Il computer ha lasciato una carta sul tavolo."); }
							else {
										  prendiCarta(g,c1,tav,1);
										  outtextxy(10,455,"Il computer ha preso una carta dal tavolo."); }
	  }
	  g->giocatore[1].carte.n= g->giocatore[0].carte.n;
}

int controlloTavolo(Carta c, CarteSulTavolo t)
//torna la posizione della carta sul tavolo uguale alla carta "c", -1 altrimenti
{
    int i=0;
    for(i=0;i<t.n;i++)
        if(c.valore==(t.carta[i].valore))
            return i;
    return -1;
}

int controlloMazzetto(Carta gioc, Carta avv)
//torna 1 se le ultime carte "gioc" "avv" dei mazzetti sono uguali, -1 altrimenti
{
    if (gioc.valore==avv.valore)
        return 1;
    return -1;
}

void rubaMazzo(Mazzetto *d, Mazzetto *s)
//mette il mazzetto sorgente "s" nel mazzetto destinatario "d"
{
    d->ultima = s->ultima;
    d->tot = d->tot + s->tot + 1;
    s->tot = 0;
}

void lasciaCarta(Gioco *g, int cmano, int gioc)
//toglie la carta di posizione "cmano" del giocatore "gioc" e la mette sul tavolo
{
//mette l'ultima carta delle carte in mano nella posizione di quella lasciata
    g->tavolo.carta[g->tavolo.n] = g->giocatore[gioc].carte.carta[cmano];
    g->giocatore[gioc].carte.carta[cmano] = g->giocatore[gioc].carte.carta[(g->giocatore[gioc].carte.n)-1];
//incrmenta il numero di carte sul tavolo e decrementa quelle in mano al giocatore
    g->tavolo.n ++;
    g->giocatore[gioc].carte.n --;
}

void prendiCarta(Gioco *g,int cmano,int ctav,int gioc)
//prende la carta di posizione "cmano" del giocatore "gioc" e la carta sul tavolo di posizione "ctav", e le mette nel mazzetto del giocatore
{
//sposta la carta scelta nel mazzetto e viene incrementato il numero totale di carte del mazzetto
    g->giocatore[gioc].mazzetto.ultima = g->tavolo.carta[ctav];
    g->giocatore[gioc].mazzetto.tot = g->giocatore[gioc].mazzetto.tot + 2;
//mette le ultime carte dl tavolo e della mano nel posto occupato dalle due carte utilizzate
    g->tavolo.carta[ctav] = g->tavolo.carta[(g->tavolo.n)-1];
    g->giocatore[gioc].carte.carta[cmano] = g->giocatore[gioc].carte.carta[(g->giocatore[gioc].carte.n)-1];
//vengono decrementati il numero di carte sul tavolo e il numero di carte in mano
    g->tavolo.n--;
    g->giocatore[gioc].carte.n--;
}

/** FINE DELLA DEFINIZIONE DELLE FUNZIONI DI GIOCO **/

// disegna il tavolo di gioco comprensivo di sfondo, carte del tavolo, carte dei giocatori e rispettivi mazzetti
void disegnaTavolo(Gioco g) {
	int i,top,left,right,bottom,x1,y1,x2,y2;

	 cancellaSchermo(453);

	 setcolor(2); // tavolo verde
	 for(i=0,x1=0,y1=0,x2=640,y2=0;i<400;i++,y1++,y2++) {
							  line(x1,y1,x2,y2);
							  }

	 setcolor(15);  //rettangolo bianco in torno
	 for(i=0,top=0,left=0,right=639,bottom=479;i<2;i++,top++,left++,right--,bottom--) {
							 rectangle(left,top,right,bottom);
							 }

	 // divisione con mosse
	 for(i=0,x1=0,y1=400,x2=640,y2=400;i<2;i++,y1++,y2++) {
							  line(x1,y1,x2,y2);
							  }

	 // divisione con storyboard
	 for(i=0,x1=0,y1=435,x2=640,y2=435;i<2;i++,y1++,y2++) {
							  line(x1,y1,x2,y2);
							  }

	titolo();
	 if (g.mazzo.n!=0) {
		disegnaMazzo(); }
	 disegnaCarteTavolo(g.tavolo);
	disegnaCarte(g.giocatore[0].carte,g.giocatore[0].nome);
	disegnaMazzetto(g.giocatore[0].mazzetto);
	disegnaPc(g.giocatore[1].carte.n);
	disegnaMazzetto2(g.giocatore[1].mazzetto);
	// fine
}

void inizializzaGrafica(void) {

	/* request autodetection */
	int gdriver = DETECT, gmode, errorcode;

	/* initialize graphics and local variables */
	initgraph(&gdriver, &gmode, "C:\\RUBAMAZZ");

	/* read result of initialization */
	errorcode = graphresult();

	if (errorcode != grOk) { /* an error occurred */
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		printf("Press any key to halt:");
		getch();
		exit(1);
	}
}

void disegnaCarte(CarteInMano c,char nome[]) {

	// disegna le carte in mano dell'utente tramite la funzione "disegna carta"
	char valore[3]=" a";
	char sopra[3]="a:";
	int x1=60,y1=220,i,left=60,right=110,testox;
	char seme[2]="b";
	settextstyle(7,0,3);
	setcolor(15);
	outtextxy(60,170,nome);
	settextstyle(0,0,1);
	for(i=0;i<c.n;i++) {
		setcolor(15);
		testox=((left+right)/2)-4;
		sopra[0]=i+49;
		outtextxy(testox,y1-10,sopra);
		seme[0]=c.carta[i].seme;
		if (c.carta[i].valore==10) {
			valore[0]=49;
			valore[1]=48;
			testox+=4; }
		else {
			valore[0]=32;
			valore[1]=c.carta[i].valore+48; }
		setcolor(15);
		disegnaCarta(c.carta[i],x1,y1);
		x1=x1+60;
		y1=220;
		left=left+60;
		right=right+60;
		}
}

void disegnaMazzo(void) {
		// disegna il mazzo di carte non ancora distribuite
	  int i,x1,y1,x2,y2;
	  setcolor(15);
	  for(i=0,x1=20,y1=60,x2=90,y2=60;i<100;i++,y1++,y2++) {
							  line(x1,y1,x2,y2);
							  }
	 setcolor(1);
	 rectangle(20,60,90,160);
	 rectangle(19,59,89,159);

	 for(i=0,x1=20,y1=60,x2=90,y2=160;i<14;i++,x1=x1+5,y2=y2-7) {
							  line(x1,y1,x2,y2);
	 }

	 for(i=0,x1=20,y1=60,x2=90,y2=160;i<14;i++,x2=x2-5,y1=y1+7) {
							  line(x1,y1,x2,y2);
	 }


}

void disegnaMazzetto(Mazzetto m) {
	// disegna l'ultima carta presente nel mazzetto dell'utente e scrive quante carte ci sono in totale nel mazzetto
	char valore[3]=" a";
	int x1=70,y1=320,left=70,right=120,testox;
	char seme[2]="b";
	char tot[3]=" c";
	setcolor(15);
	settextstyle(0,0,1);
	testox=((left+right)/2)-4;
	outtextxy(60,305,"Mazzetto:");
	seme[0]=m.ultima.seme;
	if (m.ultima.valore==10) {
			valore[0]=49;
			valore[1]=48;
			testox+=4; }
	else {
			valore[0]=32;
			valore[1]=m.ultima.valore+48; }
	setcolor(15);
	if (m.tot!=0) {
		disegnaCarta(m.ultima,x1,y1); }
	setcolor(15);
	outtextxy(142,330,"numero carte");
	outtextxy(130,345,"totali mazzetto:");
	tot[0]=(m.tot)/10+48;
	tot[1]=(m.tot)%10+48;
	settextstyle(7,0,2);
	outtextxy(180,360,tot);
	settextstyle(0,0,1);
}

void disegnaPc(int n) {
	// disegna le carte del computer
	int x1=410,xx1,xx2,yy1,yy2,y1=220,x2=460,y2=220,i=0,j,k,left=410,top=220,right=460,bottom=290;
	for(i=0;i<n;i++) {
		settextstyle(7,0,3);
		setcolor(15);
		outtextxy(435,170,"Computer");
		settextstyle(0,0,1);
		setcolor(15);
		for(j=0;j<70;j++,y1++,y2++)
			line(x1,y1,x2,y2);

		setcolor(1);

		rectangle(left,top,right,bottom);
		rectangle(left-1,top-1,right-1,bottom-1);

		yy1=220;
		yy2=290;

		for(k=0,xx1=x1,xx2=x2;k<10;k++,xx1=xx1+5,yy2=yy2-7) {
							  line(xx1,yy1,xx2,yy2);
	 }
		yy1=220;
		yy2=290;

		for(k=0,xx1=x1,xx2=x2;k<10;k++,xx2=xx2-5,yy1=yy1+7) {
							  line(xx1,yy1,xx2,yy2);
	 }
		x1=x1+60;
		x2=x2+60;
		y1=220;
		y2=220;
		left=left+60;
		right=right+60;
		}
}

void disegnaMazzetto2(Mazzetto m) {
	// disegna l'ultima carta presente nel mazzetto del pc e scrive quante carte ci sono in totale nel mazzetto
	char valore[3]=" a";
	int x1=530,y1=320,left=530,right=580,testox;
	char seme[2]="b";
	char tot[3]=" c";
	settextstyle(7,0,3);
	setcolor(15);
	testox=((left+right)/2)-4;
	settextstyle(0,0,1);
	outtextxy(520,305,"Mazzetto:");
	seme[0]=m.ultima.seme;
	if (m.ultima.valore==10) {
			valore[0]=49;
			valore[1]=48;
			testox+=4; }
	else {
			valore[0]=32;
			valore[1]=m.ultima.valore+48; }
	setcolor(15);
	if (m.tot!=0) {
		disegnaCarta(m.ultima,x1,y1); }
	setcolor(15);
	outtextxy(408,330,"numero carte");
	outtextxy(396,345,"totali mazzetto:");
	tot[0]=(m.tot)/10+48;
	tot[1]=(m.tot)%10+48;
	settextstyle(7,0,2);
	outtextxy(440,360,tot);
	settextstyle(0,0,1);
}

void disegnaCartaTavolo(Carta c,int xx1, int yy1) {
	// disegna una carta sul tavolo in posizione xx1,yy1
	int left,top,right,bottom,x1,y1,x2,y2,testox,testox2,j;
	x1=xx1;
	y1=yy1;
	x2=x1+35;
	y2=y1;
	left=x1;
	top=y1;
	right=x2;
	bottom=top+50;
	char valore[3]=" a";
	char seme[2]="b";
	setcolor(15);
	testox=((left+right)/2)-4;
	testox2=testox;
	settextstyle(0,0,1);
	seme[0]=c.seme;
	if (c.valore==10) {
			valore[0]=49;
			valore[1]=48;
			testox+=4; }
	else {
			valore[0]=32;
			valore[1]=c.valore+48; }
	for(j=0;j<50;j++,y1++,y2++)
			line(x1,y1,x2,y2);

	if(c.seme<=4)
			setcolor(12);
	else
			setcolor(0);

	rectangle(left,top,right,bottom);
	rectangle(left-1,top-1,right-1,bottom-1);
	outtextxy(testox-7,yy1+15,valore);
	outtextxy(testox2,yy1+25,seme);
}

void disegnaCarta(Carta c, int xx1, int yy1) {
	// disegna una carta dell'utente in posizione xx1,yy1
	int left,top,right,bottom,x1,y1,x2,y2,testox,testox2,j;
	x1=xx1;
	y1=yy1;
	x2=x1+50;
	y2=y1;
	left=x1;
	top=y1;
	right=x2;
	bottom=top+70;
	char valore[3]=" a";
	char seme[2]="b";
	setcolor(15);
	testox=((left+right)/2)-4;
	testox2=testox;
	settextstyle(0,0,1);
	seme[0]=c.seme;
	if (c.valore==10) {
			valore[0]=49;
			valore[1]=48;
			testox+=4; }
	else {
			valore[0]=32;
			valore[1]=c.valore+48; }
	for(j=0;j<70;j++,y1++,y2++)
			line(x1,y1,x2,y2);

	if(c.seme<=4)
			setcolor(12);
	else
			setcolor(0);

	rectangle(left,top,right,bottom);
	rectangle(left-1,top-1,right-1,bottom-1);
	outtextxy(testox-7,yy1+25,valore);
	outtextxy(testox2,yy1+35,seme);
}

void disegnaCarteTavolo(CarteSulTavolo t) {
	//disegna tutte le carte presenti sul tavolo tramte la funzione "disegnaCartaTavolo"
	int i,x=120,y=60;
	if (t.n<12) {
		for(i=0;i<t.n;i++) {
			disegnaCartaTavolo(t.carta[i],x,y);
			x=x+47;
		}
	}
	else {
		for(i=0;i<11;i++) {
			disegnaCartaTavolo(t.carta[i],x,y);
			x=x+47;
		}
		x=120;
		y=120;
		for(i=11;i<t.n;i++) {
			disegnaCartaTavolo(t.carta[i],x,y);
			x=x+47;
		}
	}
}

void pulisciMosse(void) {
	// cancella il pezzetto di schermo dove vengono visualizzati i messaggi per l'utente
	int i,x1=2,y1=405,x2=638,y2=405;
	setcolor(0);
	for(i=0;i<30;i++,y1++,y2++) {
		line(x1,y1,x2,y2); }
	setcolor(15);
}

void illuminaCarta(int n) {
	// crea un rettangolo giallo intorno alla carta "n" prescelta dall'utente
	int left=58,top=218,right=111,bottom=291;
	setcolor(14);
	switch(n) {
		case 0: {	rectangle(left,top,right,bottom);
						break; }
		case 1: {	rectangle(left+60,top,right+60,bottom);
						break; }
		case 2: {	rectangle(left+120,top,right+120,bottom);
						break; }
		}
		setcolor(15);
}

void togliIlluminazione(void) {
	// toglie il rettangolo giallo intorno alle carte dell'utente
	int i,left=58,top=218,right=111,bottom=291;
	setcolor(2);
	for(i=0;i<3;i++,right+=60,left+=60) {
		rectangle(left,top,right,bottom); }
   setcolor(15);
}

void illuminaNome(char nome[],int x) {
	// colora il nome del giocatore che ha il turno di giallo
	setcolor(14);
	settextstyle(7,0,3);
	outtextxy(x,170,nome);
	setcolor(15);
	settextstyle(0,0,1);
}

void cancellaSchermo(int tot) {
	// cancella lo schermo da posizione 0 a "tot"
	int i,x1,y1,x2,y2,left,top,right,bottom;
	setcolor(0); // cancella tutto
	 for(i=0,x1=0,y1=0,x2=640,y2=0;i<tot;i++,y1++,y2++) {
							  line(x1,y1,x2,y2);
							  }
	 setcolor(15);  //rettangolo bianco in torno
	 for(i=0,top=0,left=0,right=639,bottom=479;i<2;i++,top++,left++,right--,bottom--) {
							 rectangle(left,top,right,bottom);
							 }
}

void introduzione(char nome[]) {
	// manda a video l'introduzione al gioco
	 cancellaSchermo(480);
	 titolo();
	 intrNome(nome);
}

void intrNome(char nome[]) {
	// riceve il nome dell'utente da tastiera
	char name[2]="a";
	int i,n,x=260;
	setcolor(15);
	settextstyle(1,0,2);
	setcolor(3);
	 outtextxy(35,100,"Introduci il tuo nome (max 12 caratteri) e premi invio");
	 i=0;
	 do {
		do {
			n=getch(); }
		while(n==8);
		if (n==27)
			fine();
		if(n!=13) {
			nome[i]=n;
			name[0]=n;
			outtextxy(x,130,name);
			if(n=='m' || n=='w')
				x+=8;
			x+=12;
			i++; }
	 nome[i]='\0'; }
	 while((n!=13)&&(i<12));
	 settextstyle(0,0,1);
}

int menu(char nome[]) {
	//manda a video il menu di scelta del gioco
	int x=120,y=140,n;
	char a[2]="a";
	cancellaSchermo(480);
	titolo();
	settextstyle(0,0,2);
	setcolor(10);
	outtextxy(x+130,y,"Opzioni:");
	setcolor(14);
	outtextxy(x,y+40,"1 - Cambia il nome");
	setcolor(12);
	outtextxy(x,y+80,"2 - Regole e comandi del gioco");
	setcolor(13);
	outtextxy(x,y+120,"3 - Gioca!!!");
	setcolor(11);
	outtextxy(x,y+160,"Esc - Esci");
	setcolor(15);
	outtextxy(x,y+200,"Scelta -> ");
	do {
		n=getch(); }
	while(((n<49)||(n>51))&&(n!=27));
	a[0]=n;
	outtextxy(x+150,y+200,a);
	switch(n) {
		case 49: { introduzione(nome);
						break; }
		case 50: { regole();
						break; }
		}
	return n;
}

void regole(void) {
	// manda a video le regole del gioco
	cancellaSchermo(480);
	titolo();
	settextstyle(0,0,2);
	setcolor(12);
	outtextxy(100,70,"Regole e comandi del gioco:");
	settextstyle(6,0,1);
	setcolor(15);
	outtextxy(10,90,"Quando dal menu si sceglie l'opzione 3(Gioca) viene visualizzato il tavolo di gioco.");
	outtextxy(10,110,"In alto, di fianco al mazzo, sono posizionate le carte sul tavolo.");
	outtextxy(10,130,"Piu in basso a sinistra sono posizionate le vostre carte, sulla destra quelle del pc.");
	outtextxy(10,150,"Siete sempre voi a cominciare il gioco. Le vostre carte sono numerate da 1 a 3.");
	outtextxy(10,170,"Al momento della richiesta (Carta ->) bisogna introdurre");
	outtextxy(10,190,"il numero della carta (1, 2 o 3) che si vuole giocare");
	outtextxy(10,210,"Viene poi richiesto di introdurre la mossa che si vuole effettuare:");
	outtextxy(30,230,"- M per rubare il mazzetto del computer");
	outtextxy(30,250,"- T per prendere una carta dal tavolo");
	outtextxy(30,270,"- L per lasciare sul tavolo la carta scelta");
	outtextxy(10,290,"Il programma controlla che la carta e la mossa introdotte siano coerenti");
	outtextxy(10,310,"e in caso contrario richiedera' la ripetizione della carta e della mossa(Carta ->)...");
	outtextxy(10,330,"Il segnale che permette di capire di chi e' il turno, e' la colorazione gialla,");
	outtextxy(10,350,"anziche' bianca del nome del giocatore e la scritta 'nome 's turn' in basso");
	outtextxy(10,370,"In ogni momento e' possibile premere ESC per uscire dal gioco.");
	outtextxy(10,390,"Attenzione: premendo ESC non c'e piu modo di tornare indietro e il gioco termina.");
	outtextxy(10,410,"Una volta conclusa la partita, apparira' una videata che informa su chi ha vinto");
	outtextxy(10,430,"e si puo' scegliere se cominciare una nuova partita o terminare il programma.");
	settextstyle(0,0,1);
	outtextxy(185,465,"Premi un tasto per tornare al menu");
	getch();
}

void titolo(void) {
	// scrive il titolo del gioco
	settextstyle(7,0,6);
	setcolor(14);
	outtextxy(135,1,"Il Rubamazzo");
	settextstyle(0,0,1);
	setcolor(15);
}

void fine(void) {
	//manda a video la schermata finale del gioco, da cui si puo solo chiudere il programma
	cancellaSchermo(480);
	titolo();
	settextstyle(0,0,2);
	setcolor(15);
	outtextxy(110,100,"Grazie per aver utilizzato");
	settextstyle(7,0,6);
	setcolor(14);
	outtextxy(135,135,"Il Rubamazzo");
	settextstyle(0,0,2);
	setcolor(15);
	outtextxy(210,220,"Programmed by:");
	settextstyle(0,0,3);
	setcolor(1);
	outtextxy(260,260,"vtt89");
	setcolor(2);
	outtextxy(240,310,"Wolf_89");
	setcolor(3);
	outtextxy(275,360,"cj89");
	setcolor(4);
	outtextxy(275,410,"JJ#9");
	settextstyle(0,0,1);
	setcolor(15);
	outtextxy(150,465,"Premi un tasto per terminare il programma...");
	getch();
	exit(0);
}

int vincitore(Giocatore g[])
//stampa a video il nome del giocatore vincitore della partita; se  finita in pareggio viene comunicato all'utente
// torna 1 se bisogna uscire altrimenti 0 per una nuova partita
{
	int vinc,esc;
	if(g[0].mazzetto.tot>g[1].mazzetto.tot)
		  vinc=0;
	else
	if(g[0].mazzetto.tot<g[1].mazzetto.tot)
		vinc=1;
	else
		vinc=-1;
	switch(vinc) {
		case 0: { grVincitore(g[0].nome,30);
					 break; }
		case 1: { grVincitore("Computer",120);
					 break; }
		case -1: { grPareggio();
					  break; }
	}
	settextstyle(0,0,1);
	setcolor(15);
	outtextxy(60,465,"Premi Esc per uscire o qualunque altro tasto per una nuova partita");
	esc=getch();
	if (esc==27)
		return 1;
	else
		return 0;
}

void grVincitore(char nome[],int xnome){
	// manda a video la grafica relativa a chi ha vinto la partita
	int i,x,y;
	cancellaSchermo(480);
	titolo();
	settextstyle(0,0,6);

	for (i=0,x=620,y=60;i<40;x-=14,y++,i++) {
		setcolor(1);
		outtextxy(x,y,"The");
		delay(7);
		setcolor(0);
		outtextxy(x,y,"The");
	}
	setcolor(1);
	outtextxy(x,y,"The");

	for (i=0,x=600,y=150;i<30;x-=10,i++) {
		setcolor(11);
		outtextxy(x,y,"winner");
		delay(7);
		setcolor(0);
		outtextxy(x,y,"winner");
	}
	setcolor(11);
	outtextxy(x,y,"winner");

	for (i=0,x=20,y=460;i<50;x+=2,y-=5,i++) {
		setcolor(10);
		outtextxy(x,y,"is");
		delay(7);
		setcolor(0);
		outtextxy(x,y,"is");
	}
	setcolor(10);
	outtextxy(x,y,"is");

	settextstyle(7,0,8);
	for (i=0,x=xnome,y=300;i<10;i++) {
		if (i!=0)
			delay(600);
		setcolor(14);
		outtextxy(x,y,nome);
		delay(600);
		setcolor(0);
		outtextxy(x,y,nome);
	}
	setcolor(14);
	outtextxy(xnome,300,nome);

}

void grPareggio(void){
	// manda a video la grafica relativa al pareggio della partita
	int i,x,y;
	cancellaSchermo(480);
	titolo();
	settextstyle(0,0,6);

	for (i=0,x=620,y=60;i<40;x-=14,y++,i++) {
		setcolor(1);
		outtextxy(x,y,"La");
		delay(7);
		setcolor(0);
		outtextxy(x,y,"La");
	}
	setcolor(1);
	outtextxy(x,y,"La");

	for (i=0,x=600,y=150;i<30;x-=13,i++) {
		setcolor(11);
		outtextxy(x,y,"partita");
		delay(7);
		setcolor(0);
		outtextxy(x,y,"partita");
	}
	setcolor(11);
	outtextxy(x,y,"partita");

	for (i=0,x=20,y=460;i<50;x+=2,y-=5,i++) {
		setcolor(10);
		outtextxy(x,y,"e'");
		delay(7);
		setcolor(0);
		outtextxy(x,y,"e'");
	}
	setcolor(10);
	outtextxy(x,y,"e'");

	for (i=0,x=420,y=260;i<20;x-=5,y++,i++) {
		setcolor(1);
		outtextxy(x,y,"finita");
		delay(7);
		setcolor(0);
		outtextxy(x,y,"finita");
	}
	setcolor(1);
	outtextxy(x,y,"finita");

	for (i=0,x=50,y=350;i<30;y--,i++) {
		setcolor(11);
		outtextxy(x,y,"in");
		delay(7);
		setcolor(0);
		outtextxy(x,y,"in");
	}
	setcolor(11);
	outtextxy(x,y,"in");

	for (i=0,x=20,y=450;i<20;x+=7,y-=4,i++) {
		setcolor(10);
		outtextxy(x,y,"parita'...");
		delay(7);
		setcolor(0);
		outtextxy(x,y,"parita'...");
	}
	setcolor(10);
	outtextxy(x,y,"parita'...");
}

void cancellaStory(int y1, int n) {
	// cancella la parte di schermo sottostante alle mosse del giocatore
	int x1,x2,y2,i;
	setcolor(0); // cancella STORY
	for(i=0,x1=2,x2=635,y2=y1;i<n;i++,y1++,y2++) {
							  line(x1,y1,x2,y2);  }
	setcolor(15);

}

void copiaStringa(char dest[], char src1[], char src2[]) {
	// copia nella stringa "dest", la stringa "src1" e di seguito, dopo uno spazio, la stringa "src2"
	int i=0,j=0;
	do {
		dest[i]=src1[i];
		i++; }
	while(src1[i]!='\0');
	dest[i]=32;
	i++;
	do {
		dest[i]=src2[j];
		i++;
		j++; }
	while(src2[j]!='\0');
	dest[i]='\0';
}

